/*

Copyright (C) 2009 Jaroslav Barton <djaara@djaara.net>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef FMENROLL_H_
#define FMENROLL_H_

#include <KDialog>

#include "FingerManagerDevicesModel.h"
#include "FMDbusConn.h"
#include "EnrollStatus.h"
#include "SensorAnimLabel.h"

class QLabel;
class QWidget;
class QCheckBox;
class QTimer;
class QVBoxLayout;
class QHBoxLayout;

class FMEnroll : public KDialog {
	Q_OBJECT

	public:
		FMEnroll(DeviceModel device, const QString &loginName, int finger = 6, QWidget *parent = 0);
		~FMEnroll();

	private slots:
		void		enrollStatusSlot(const QString &result, bool done);
		void		timeoutSlot();

	private:
		void		retranslate();
		void		initComponents(int enrollStages);
		void 		setStatusMessage(const QString &result);
		void 		getIface();

		QLabel		    *m_statusLabel;
		QLabel		    *m_actualStatusLabel;
		EnrollStatus	**m_stages;
		SensorAnimLabel *m_animLabel;
		QWidget		    *m_mainPanel;
		
		int		        m_finger;
		QString		    m_loginName;
		DeviceModel	    m_device;
		FMDbusConn	    *m_dbc;
		int		        m_enrollStages;
		int		        m_actualStage;
		QString		    m_scanType;
		QTimer		    *m_timer;
};

#endif
